Bug 9227 - civclient падает с assertion failed
: civclient падает с assertion failed
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/freeciv-client)
: unstable
: all Linux
: P2 major
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2006-03-11 15:11 by
Modified: 2007-08-23 08:19 (History)


Attachments
civgame+0680.sav.gz (168.39 KB, application/octet-stream)
2006-03-12 11:54, Anton Farygin
no flags Details


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2006-03-11 15:11:18
Время от времени civclient падает с сообщением:

(civclient:6333): Pango-WARNING **: Invalid UTF-8 string passed to
pango_layout_set_text()

Pango-ERROR **: file pango-layout.c: line 3286 (pango_layout_check_lines):
assertion failed: (end <= (layout->text + layout->length))
aborting...
Trace/breakpoint trap

Система: x86_64, последний Sisyphus, локаль ru_RU.UTF-8
------- Comment #1 From 2006-03-12 11:54:07 -------
Created an attachment (id=1424) [details]
civgame+0680.sav.gz

save, на открытии которого падает freeciv.

Вылезает это где-то в районе переводов. С отладкой, добавленной в pango, видно,
что ему не нравится текст "Босния и Герцеговина".
text:Компьютер
text:Filipovic Nikola
text:Босния и Герцего&#65533;

(civclient:13292): Pango-WARNING **: Invalid UTF-8 string passed to
pango_layout_set_text()

Pango-ERROR **: file pango-layout.c: line 3287 (pango_layout_check_lines):
assertion failed: (end <= (layout->text + layout->length))
aborting...
Trace/breakpoint trap
------- Comment #2 From 2006-03-12 11:56:54 -------
В локали C не воспроизводится, в локали ru_RU.KOI8-R тоже падает.
------- Comment #3 From 2006-03-12 12:34:57 -------
Всё дело в размере Nation в структуре packet_game_load

способ воспроизведения 100%: начать игру под Босния и Герцеговина, сохранить,
выйти и загрузить сохранённую игру.
------- Comment #4 From 2006-03-13 03:44:19 -------
MAX_LEN_NAME is too short?
------- Comment #5 From 2006-03-13 16:15:31 -------
я пробовал увеличить. кончилось это плохо
Хотя если честно я пробовал увеличить только в клиенте.. наверное потому и было
плохо (там пакет формируется на сервере).
на досуге проверю.

Кстати, увеличение этого значения не повлияет на связь с другими freeciv серверами ?

------- Comment #6 From 2007-04-06 16:31:59 -------
Что-то изменилось ?
------- Comment #7 From 2007-04-25 10:05:38 -------
Воспроизводится ли с текущей (2.1.0-alt0.b4) версией? Вроде в апстриме что-то
на
эту тему фиксили.
------- Comment #8 From 2007-08-23 08:19:14 -------
Fixed in 2.1.0-alt0.b4

> Хотя если честно я пробовал увеличить только в клиенте.. наверное потому и
было плохо (там пакет формируется на сервере).

Формируется на сервере, разбирается на клиенте, описания пакетов на сервере и
клиенте должны совпадать. При изменении описания какого-либо пакета необходимо
также изменить строку "network capabilities" - упрощённо говоря, версию
протокола сетевого обмена.

> Кстати, увеличение этого значения не повлияет на связь с другими freeciv
серверами ?

Повлияет, у клиента и сервера будут разные версии протокола обмена под одним
именем -> segfaults expected.